# -*- coding: utf-8 -*-
##############################################################################
#
#    Author: Guewen Baconnier
#    Copyright 2013 Camptocamp SA
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import orm, fields
from openerp.tools.translate import _


class sale_order(orm.Model):
    _inherit = 'sale.order'

    _columns = {
        'cancel_reason_id': fields.many2one(
            'sale.order.cancel.reason',
            string="Reason for cancellation",
            readonly=True,
            ondelete="restrict"
        ),
    }


class sale_order_cancel_reason(orm.Model):
    _name = 'sale.order.cancel.reason'
    _description = 'Sale Order Cancel Reason'
    _columns = {
        'name': fields.char('Reason', required=True, translate=True),
    }
